unit gifSettingsWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ColorContainer, ExtCtrls, RejbrandColorDialog;

type
  TColorContainerHelper = class helper for TColorContainer
    procedure MakeTabStopWork;
  end;

  TGIFfrm = class(TForm)
    GroupBox1: TGroupBox;
    eWidth: TLabeledEdit;
    eHeight: TLabeledEdit;
    eDelay: TLabeledEdit;
    GroupBox2: TGroupBox;
    cbBall: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    eBallSize: TEdit;
    Label3: TLabel;
    eBallSpeed: TEdit;
    Label4: TLabel;
    eInitialFrame: TEdit;
    cbAutoRotate: TCheckBox;
    Label5: TLabel;
    eRotSpeed: TEdit;
    cbColouredLines: TCheckBox;
    cbThickLines: TCheckBox;
    cbLight: TCheckBox;
    cbAxes: TCheckBox;
    btnOk: TButton;
    btnCancel: TButton;
    eNumRots: TLabeledEdit;
    ccBallColour: TColorContainer;
    procedure FormCreate(Sender: TObject);
    procedure ccBallColourKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ccBallColourClick(Sender: TObject);
    procedure CheckCanCreate(Sender: TObject);
  private
    procedure SelectBallColour;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GIFfrm: TGIFfrm;

implementation

{$R *.dfm}

{ TColorContainerHelper }

procedure TColorContainerHelper.MakeTabStopWork;
begin
  TColorContainer(Self).TabStop := true;
  TColorContainer(Self).TabOrder := 1;
end;

procedure TGIFfrm.ccBallColourClick(Sender: TObject);
begin
  ccBallColour.SetFocus;
  SelectBallColour;
end;

procedure TGIFfrm.ccBallColourKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key in [VK_RETURN, VK_SPACE] then SelectBallColour;
end;

procedure TGIFfrm.CheckCanCreate(Sender: TObject);
begin
  btnOk.Enabled := cbBall.Checked or cbAutoRotate.Checked;
end;

procedure TGIFfrm.SelectBallColour;
begin
  with TRejbrandColorDialog.Create(nil) do
    try
      Color := ccBallColour.Color;
      if Execute then
        ccBallColour.Color := Color;
    finally
      Free;
    end;
end;

procedure TGIFfrm.FormCreate(Sender: TObject);
begin
  ccBallColour.MakeTabStopWork;
end;

end.
